Bug 216555 - Virtual disk size wraps around at 2 TB mark
Virtual disk size wraps around at 2 TB mark
Product: Fedora
Classification: Fedora
Component: kernel-xen (Show other bugs)
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Stephen Tweedie
Virtualization Bugs
Depends On:
Blocks: 216556 232608
  Show dependency treegraph
Reported: 2006-11-20 20:33 EST by Daniel Berrange
Modified: 2009-12-14 15:39 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-02-26 18:45:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Patch for blktap based disks (3.13 KB, patch)
2006-11-21 17:45 EST, Daniel Berrange
no flags Details | Diff

  None (edit)
Description Daniel Berrange 2006-11-20 20:33:29 EST
Description of problem:
If I create a virtual disk (either a file, or block device backed) in the dom0
host with a size of 5 TB, and export this to a guest DomU, the domu will only
see it as being 1 TB in size. It looks as if the Xen virtual disk driver is
wrapping around at the 2 TB mark.

Version-Release number of selected component (if applicable):

How reproducible:
Always (on 32-bit)

Steps to Reproduce:
1. Create an block device 7 TB in size
2. Export this to the DomU in the guest config file
3. Look at /proc/partitions inside the guest kernel
4. Look at /proc/partitions in the dom0 host kernel
Actual results:
The #blocks column for the disk is different in DomU & Dom0

Expected results:
The #blocks seen in DomU matches #blocks seen in Dom0

Additional info:
The same problem occurs for file backed virtual disks on 32-bit host/guest.

There is no problem on 64-bit kernels - I have exported disks as large as 15 PB
 to the guest.

This is all testing with paravirt guests. Not verified if fully virt guests have
any issues yet.

Post from Ian upstream suggests 32-bit wraparound in blkfront driver

Comment 1 Robin Bowes 2006-11-20 21:09:13 EST
I'm seeing the same thing.

I'm trying to make a 2.73TB ext3 FS available to a DomU guest.

It's docmented here:

Comment 2 Daniel Berrange 2006-11-21 07:39:53 EST
Patch committed in xen-unstable.hg

Comment 3 Daniel Berrange 2006-11-21 17:44:56 EST
I have tested the patch listed in comment #2 and confirmed it fixes operation of
file: and phy: backed disks > 2 TB in size. It does not, however, fix tap:aio:
backed disks.

Comment 4 Daniel Berrange 2006-11-21 17:45:59 EST
Created attachment 141844 [details]
Patch for blktap based disks

This additional patch fixes blktap based disks which are > 2TB
Comment 5 Robin Bowes 2006-11-22 05:39:37 EST
Woohoo! I installed the patched kernel & xen RPMS this morning and I can now see
m y large partition correctly in the DomU guest.

Thanks for the quick fix and help rebuilding the RPMS.
Comment 6 Robin Bowes 2007-01-02 18:51:07 EST
Can I get an update on the status of this issue?

i.e. has the patch been applied upstream yet? When will we see RPMS with this fixed?


Comment 8 Red Hat Bugzilla 2007-07-24 21:36:19 EDT
change QA contact
Comment 9 Chris Lalancette 2008-02-26 18:45:03 EST
This report targets FC6, which is now end-of-life.

Please re-test against Fedora 7 or later, and if the issue persists, open a new bug.


Note You need to log in before you can comment on or make changes to this bug.